(******************************************************************************)
(* Copyright © Joly Clément, 2014-2016                                        *)
(*                                                                            *)
(*  leowzukw@oclaunch.eu.org                                                  *)
(*                                                                            *)
(*  Ce logiciel est un programme informatique servant à exécuter              *)
(*  automatiquement des programmes à l'ouverture du terminal.                 *)
(*                                                                            *)
(*  Ce logiciel est régi par la licence CeCILL soumise au droit français et   *)
(*  respectant les principes de diffusion des logiciels libres. Vous pouvez   *)
(*  utiliser, modifier et/ou redistribuer ce programme sous les conditions    *)
(*  de la licence CeCILL telle que diffusée par le CEA, le CNRS et l'INRIA    *)
(*  sur le site "http://www.cecill.info".                                     *)
(*                                                                            *)
(*  En contrepartie de l'accessibilité au code source et des droits de copie, *)
(*  de modification et de redistribution accordés par cette licence, il n'est *)
(*  offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons, *)
(*  seule une responsabilité restreinte pèse sur l'auteur du programme,  le   *)
(*  titulaire des droits patrimoniaux et les concédants successifs.           *)
(*                                                                            *)
(*  A cet égard  l'attention de l'utilisateur est attirée sur les risques     *)
(*  associés au chargement,  à l'utilisation,  à la modification et/ou au     *)
(*  développement et à la reproduction du logiciel par l'utilisateur étant    *)
(*  donné sa spécificité de logiciel libre, qui peut le rendre complexe à     *)
(*  manipuler et qui le réserve donc à des développeurs et des professionnels *)
(*  avertis possédant  des  connaissances  informatiques approfondies.  Les   *)
(*  utilisateurs sont donc invités à charger  et  tester  l'adéquation  du    *)
(*  logiciel à leurs besoins dans des conditions permettant d'assurer la      *)
(*  sécurité de leurs systèmes et ou de leurs données et, plus généralement,  *)
(*  à l'utiliser et l'exploiter dans les mêmes conditions de sécurité.        *)
(*                                                                            *)
(*  Le fait que vous puissiez accéder à cet en-tête signifie que vous avez    *)
(*  pris connaissance de la licence CeCILL, et que vous en avez accepté les   *)
(*  termes.                                                                   *)
(******************************************************************************)

type rc_name = string;;
type rc_entry = { commands: (string * int) };;
type tmp_file = { rc: (rc_name * (rc_entry list)) list; daemon: int };;
type t = tmp_file;;

val write : t -> unit

(* Use this function to read tmp file, it will be created if necessary *)
val init : unit -> t

val verify_key_exist : key:'a -> 'a -> bool
val is_prog_in_rc : 'a list -> 'a -> bool
val log : cmd:string -> ?func:(int -> int) -> unit -> unit

(** Return current state *)
val get_current : unit -> int

(* Accurate logs *)
type accurate_log = (Rc.entry * int) list
type accurate_log_simple = (string * int) list
val get_accurate_log_complete : ?rc_name:string lazy_t -> tmp:t -> unit -> accurate_log
val get_accurate_log : ?entry_log:accurate_log -> tmp:t -> unit -> accurate_log_simple

(* Resetting command *)
val reset_cmd : rc:Rc.t -> int -> int -> unit
val reset2num : int -> unit
val reset_all : unit -> unit
